<?php

ini_set('display_errors',1);
ini_set('display_startup_errors',1);
error_reporting(E_ALL);

use ChamiloSession as Session;
/* For license terms, see /license.txt
* This is the main script of the extra_class_com plugin.
* @author Damien Renou
* @package chamilo.s_com
*/

require_once (__DIR__.'/../config.inc.php');
require_once (__DIR__.'/../inc/functions.php');

$action = isset($_GET['action']) ? Security::remove_XSS($_GET['action']) : 'add';
$id = isset($_GET['id']) ? (int) $_GET['id'] : 0;
$islog = isset($_GET['log']) ? (int) $_GET['log'] : 0;

$ObjMess = getMessageObject($id);

$form = new FormValidator('extraCom', 'post', 'extra-com-step2.php'.'?action='.$action.'&id='.$id);

$imgMess = '<a href="list.php" ><img src="../resources/img/messages_listview.png" /></a>';

$form->addElement('static','',$imgMess,'<center><img src="../resources/img/etape1.png" /></center>');

$TextFrom = $form->addText('FromName',$plugin->get_lang('fromName'),false);

$FromName = '';
$FromName = $ObjMess['FromName'];
if($FromName==''){
	$FromName = 'Chamilo LMS';
}
$TextFrom->setValue($FromName);


$TextFrom = $form->addText('FromMail',$plugin->get_lang('from'),true);

$emailDest = '';
$emailDest = $ObjMess['FromMail'];
if($emailDest==''){
	$emailDest = api_get_setting('emailAdministrator');
}
$TextFrom->setValue($emailDest);

$Text = $form->addText('Object',$plugin->get_lang('object'),true);
$Text->setValue($ObjMess['Object']);

$Groups = listGroupID();	
$Groupsoptions = array();

$Groupsoptions['all'] = 'Tous les utilisateurs';

foreach ($Groups as &$row){
	$Groupsoptions[$row['id']] = $row['name'];
}
$select = $form->addElement('select','groupslist',$plugin->get_lang('sendto'),$Groupsoptions,false,array('id'=>'groupslist'));
if($ObjMess['idGroup']!=''){
	$select->setValue($ObjMess['idGroup']);
}

Session::write('SendMessage',$ObjMess['Message']);

$config = [
	'ToolbarSet' => 'Minimal',
	'Width' => '100%',
	'Height' => '500',
];
$Text2 = $form->addHtmlEditor('Message',$plugin->get_lang('message'), false, false, $config, true);

$form->setDefaults([
	'Message' => Session::read('SendMessage'),
]);

$Text = $form->addText('doc_process',$plugin->get_lang('doc_process'),true);
$Text->setValue($ObjMess['docProcess']);

if($islog==0){
	$form->addButtonSave($plugin->get_lang('next'));
}else{

	if (file_exists('history/log'.$id.'.txt')){
		$logdetails = file_get_contents('history/log'.$id.'.txt');
		$logdetails = str_replace("Error !!!", "<br><span style='color:red;font-weight:bold;' >ERROR</span><br>", $logdetails);
		$form->addElement('static', '', '', "<div style='border:1px green solid;' >".$logdetails.":</div>");
	}
}


$htmlHeadXtra[] = '<script src="js/message-app.js" type="text/javascript" ></script>';
$htmlHeadXtra[] = '<script src="js/faketexteditor.js" type="text/javascript" ></script>';

$tpl = new Template();
$tpl->assign('form', $form->returnForm());

$content = $tpl->fetch('/chamilo_boost_com_panel/view/chamilo_boost_com_panel.tpl');

$tpl->assign('content', $content);

$tpl->display_one_col_template();

