<?php
	
	/* For licensing terms, see /license.txt */
	require_once __DIR__.'/../../../main/inc/global.inc.php';
	require_once __DIR__.'/../chamilo_boost_com_panel.php';
	require_once (__DIR__.'/../inc/functions.php');

	$language = 'en';
	$platformLanguage = api_get_interface_language();
	$iso = api_get_language_isocode($platformLanguage);
	
	if(!api_is_anonymous()){
		
		$user = api_get_user_info();
		
		if(isset($user['status'])){
			if($user['status']==SESSIONADMIN
			||$user['status']==COURSEMANAGER
			||$user['status']==PLATFORM_ADMIN
			||$user['status']==1){
			}else{
				echo "<script>location.href = '../../index.php';</script>";
				exit;
			}
		}
		
	}else{
		echo "<script>location.href = '../../index.php';</script>";
		exit;
	}

	$htmlHeadXtra[] = '<link href="css/style.css"  rel="stylesheet" type="text/css" />';
	
	$vers = 6;
	
	$plugin = chamilo_boost_com_panel::create();
	
	$id = isset($_GET['id']) ? (int) $_GET['id']:0;
	
	$table = 'chamilo_boost_com_panel';
	
    $idurl = api_get_current_access_url_id();
    
	$UrlWhere = "";
	if((api_is_platform_admin() || api_is_session_admin()) && api_get_multiple_access_url()){
        $UrlWhere = " AND id_url = $idurl ";
	}
	
	$action = isset($_GET['action']) ? Security::remove_XSS($_GET['action']):'add';

	$sql = "SELECT * FROM $table WHERE id > -1 AND is_send <> 2 $UrlWhere ORDER BY id";

	if($action=='archives'){
		$sql = "SELECT * FROM $table WHERE id > -1 AND is_send = 2 $UrlWhere ORDER BY id";
	}

	if(isset($_GET['id'])){
		$sql = "SELECT * FROM $table  WHERE id <> $id  AND is_send <> 2 $UrlWhere LIMIT 2";
	}
	
	$result = Database::query($sql);
	$terms = Database::store_result($result,'ASSOC');
	$countData = count($terms);
	
	$term = null;

	if($id>0){
		if(!empty($id)){
			$sql = "SELECT * FROM $table WHERE id = $id ";
			$result = Database::query($sql);
			$term = Database::fetch_array($result, 'ASSOC');
			if(empty($term)){
				api_not_allowed(true);
			}
		}
	}
	
	if($countData>20){

		$htmlHeadXtra[] = '<script src="js/jquery.dataTables.min.js?v='.$vers.'" type="text/javascript" language="javascript"></script>';
	
		$htmlHeadXtra[] = "<script>
		$(document).ready(function(){
			$('.message_table').DataTable({
				'iDisplayLength': 20
			});
		} );
		</script>";
	}
	
	$htmlHeadXtra[] = "<style>
		.previous{
			margin-right:10px;
			cursor:pointer;
		}
		.next{
			cursor:pointer;
		}
	</style>";

	//previous

	$form = new FormValidator('dictionary', 'post', api_get_self().'?action='.$action.'&id='.$id);
	
	$form->addText('title','Objet',true);
	
	$form->addButtonSave('&nbsp;&nbsp;'.get_lang('Create').'&nbsp;&nbsp;');
	
	switch($action){
		case 'add':

			if ($form->validate()) {
				$values = $form->getSubmitValues();
				
				$date = new DateTime();
				$year = $date->format("Y");
				$month = $date->format('m');
				$day = $date->format('j');

				$dateStr = $day.'/'.$month.'/'.$year;
				
				$groupType = $values['group1'];

				$params = [
					'title' => $values['title'],
					'date_create' => $dateStr,
					'id_url' => $idurl,
					'is_send' => 0
				];

				$result = Database::insert($table, $params);
				if ($result) {
					Display::addFlash(Display::return_message(get_lang('Added')));
				}
				header('Location: '.api_get_self());
				exit;
			}
			break;

		case 'edit':

			$form->setDefaults($term);
			if ($form->validate()) {
				$values = $form->getSubmitValues();
				$params = [
					'title' => $values['title']
				];
				Database::update($table, $params, ['id = ?' => $id]);
				Display::addFlash(Display::return_message(get_lang('Updated')));
				header('Location: '.api_get_self());
				exit;
			}
			break;

		case 'duplicate':

			$ObjMess = getMessageObject($id);

			$date = new DateTime();
			$year = $date->format("Y");
			$month = $date->format('m');
			$day = $date->format('j');

			$dateStr = $day.'/'.$month.'/'.$year;
			
			$params = [
				'title' => 'COPY '.$ObjMess['Object'],
				'date_create' => $dateStr,
				'id_url' => $idurl,
				'is_send' => 0,
				'fromname' => $ObjMess['FromName'],
				'fromvar' => $ObjMess['FromMail'],
				'base_html' => $ObjMess['Message'],
				'sendvar' => $ObjMess['idGroup'],
			];

			$result = Database::insert($table, $params);
			if ($result) {
				Display::addFlash(Display::return_message(get_lang('Added')));
			}
			header('Location: '.api_get_self());
			exit;

			break;

		case 'delete':

			if (!empty($term)){
				$params = ['is_send' => 2];
				Database::update($table, $params, ['id = ?' => $id]);
				Display::addFlash(Display::return_message(get_lang('Achived')));
				header('Location: '.api_get_self());
				exit;
			}
			break;
			
		case 'update':
			
			$sql = "ALTER TABLE chamilo_boost_com_panel ADD doc_process INT NULL DEFAULT 0 AFTER date_create;";
			Database::query($sql);

			$sql = "ALTER TABLE chamilo_boost_com_panel ADD date_send VARCHAR(12) NULL DEFAULT '' AFTER date_create;";
			Database::query($sql);
			exit;
			break;

	}
	
	$tpl = new Template("Messages");
	$tpl->assign('terms', $terms);
	$tpl->assign('form', $form->returnForm());
	
	$content = $tpl->fetch('/chamilo_boost_com_panel/view/list_com_panel-v3.tpl');

	$tpl->assign('content', $content);

	$tpl->display_one_col_template();
	