<?php

require_once __DIR__.'/../../../../main/inc/global.inc.php';

require_once __DIR__.'/../../chamilo_boost_com_panel.php';
$plugin = chamilo_boost_com_panel::create();

ini_set('display_errors',1);
ini_set('display_startup_errors',1);
error_reporting(E_ALL);

$allowToTrack = api_is_platform_admin(true, true) ||api_is_teacher() || api_is_student_boss() ||api_is_coach() || api_is_drh();

if (!$allowToTrack) {
	api_not_allowed(true);
}

//public/main/cron/fix_online_time.php

if(isset($_GET['lessonsgroup'])||isset($_GET['start'])||isset($_GET['end'])){
	
	$lessonsgroup = $_GET['lessonsgroup'];
	$dateStart = $_GET['start'];
	$dateEnd = $_GET['end'];

	$isMultipleUrl = (api_is_platform_admin() || api_is_session_admin()) && api_get_multiple_access_url();
	$urlId = api_get_current_access_url_id();
	
	$tblUser = Database::get_main_table(TABLE_MAIN_USER);
	$tblRelation = Database::get_main_table(TABLE_MAIN_USER_REL_USER);

	if ($lessonsgroup!=-1) {

		$listUsersSql = "SELECT DISTINCT user.id, user.firstname, user.lastname
		FROM usergroup_rel_user
		INNER JOIN $tblUser ON $tblUser.id = usergroup_rel_user.user_id 
		WHERE usergroup_id = $lessonsgroup and $tblUser.status = 5
		ORDER BY $tblUser.id ASC";
	
	}else{
		 
		$userId = api_get_user_id();

		$listUsersSql =  " SELECT DISTINCT tbluser.id, tbluser.firstname, tbluser.lastname, tbluser.official_code, tbluser.email ";
		$listUsersSql .= " FROM $tblUser as tbluser ";
		$listUsersSql .= " INNER JOIN $tblRelation tblRelation ";
		$listUsersSql .= " ON (tblRelation.user_id = tbluser.id) AND friend_user_id = $userId ";
		if($isMultipleUrl){
			$listUsersSql .= " INNER JOIN $access_url_rel_user_table url_rel_user";
			$listUsersSql .= " ON (tbluser.id=url_rel_user.user_id) ";
		}
		$listUsersSql .= " WHERE tbluser.status = 5 ";
		$listUsersSql .= " ORDER BY tbluser.id ASC ";

	}

	$listeusers = Database::query($listUsersSql);
	$userId = 0;
	$global_time_spent = 0;
	$log = "";
	
	$sep = ' ; ';

	$exportCsv = get_lang('User').$sep.get_lang('Percentage').$sep.$plugin->get_lang('plateformetime').$sep.$plugin->get_lang('elearningtime')."\n";

	$tableh = "<table class='greyGridTable' >";
	
	$tableh .= "<tr><thead>";
	$tableh .= "<th>".get_lang('User')."</th>";
	$tableh .= "<th>".get_lang('Percentage')."&nbsp;%</th>";
	$tableh .= "<th>".$plugin->get_lang('plateformetime')."(1)</th>";
	$tableh .= "<th>".$plugin->get_lang('elearningtime')."(2)</th>";
	$tableh .= "<th>".get_lang('FirstLogin')."</th>";
	$tableh .= "<th>".get_lang('LatestLogin')."</th>";
	$tableh .= "</thead></tr><tbody>";
	
	while($users = Database::fetch_array($listeusers)){
		
		$i = $users['id'];
		$userId = $i;

		$iuname = $users['firstname'].'&nbsp;'.$users['lastname'];
		
		$exportCsv .= $users['firstname'].' '.$users['lastname'].$sep;

		$tableh .= "<tr>";
		$tableh .= "<td>".$iuname."&nbsp;</td>";
		
		$progressStr = getProgressFull($userId)."%";
		$tableh .= "<td>&nbsp;".$progressStr."</td>";
		
		$exportCsv .= $progressStr.$sep;

		$time_spent_on_course = getTimeFull($userId,$dateStart,$dateEnd);
		$global_time_spent = $global_time_spent + $time_spent_on_course;

		$tableh .= "<td>&nbsp;".api_time_to_hms($time_spent_on_course)."</td>";
		$exportCsv .= api_time_to_hms($time_spent_on_course).$sep;

		$time_spent_on_elearning = getTimeFullElearning($userId,$dateStart,$dateEnd);

		$tableh .= "<td>&nbsp;".api_time_to_hms($time_spent_on_elearning)."</td>";
		$exportCsv .= api_time_to_hms($time_spent_on_elearning).$sep;

		$tableh .= "<td>".Tracking::get_first_connection_date($userId)."</td>";
		$tableh .= "<td>".Tracking::get_last_connection_date($userId, true)."</td>";

		$tableh .= "</tr>";
		
		$exportCsv .= "\n";

	}

	$tableh .= "<tr>";
	$tableh .= "<td>&nbsp;</td><td>Total</td>";
	$tableh .= "<td style='background-color:#585858;color:white;' >&nbsp;".api_time_to_hms($global_time_spent)."</td>";
	$tableh .= "<td></td>";
	$tableh .= "<td></td>";
	$tableh .= "<td></td>";
	
	$exportCsv .= "".$sep."Total".$sep.api_time_to_hms($global_time_spent).$sep."\n";

	$tableh .= "</tr>";

	$tableh .= "</tbody></table><br><br>";
	
	//$tableh .= $log;

	$urlIdFinal = api_get_current_access_url_id();
	$pathCSV = api_get_path(SYS_PLUGIN_PATH).'chamilo_boost_com_panel/statusers/cache/export'.$urlIdFinal.'.csv';
	$WpathCSV = api_get_path(WEB_PLUGIN_PATH).'chamilo_boost_com_panel/statusers/cache/export'.$urlIdFinal.'.csv';
	$fd = fopen($pathCSV,'w');	
    fwrite($fd,$exportCsv);
	fclose($fd);
	
	$tableh .= "<a style='position:absolute;right:10%;bottom:0px;margin-left:-16px;' href='".$WpathCSV."' target='_blank' title='Exporter' ><img src='css/export_csv.png' /></a>";

	$tableh .= "<p><i>(1) Temps estimé actif sur la plateforme (basé sur les logins)</i></p>";
	$tableh .= "<p><i>(2) Temps estimé sur les contenus e-learning (basé sur les temps d'ouvertures SCORM xAPI etc,)</i></p>";

	echo $tableh;
	//1258
}

function getProgressFull($userId){

	$sql  = " SELECT DISTINCT course.code ";
	$sql .= " FROM c_lp_item_view ";
	$sql .= " INNER JOIN course ON c_lp_item_view.c_id = course.id ";
	$sql .= " WHERE lp_view_id  ";
	$sql .= " IN (SELECT id FROM `c_lp_view` WHERE user_id = $userId);";

	$avgCourseTime = 0;
	$ttcourse = 0;
	$resultCourses = Database::query($sql);

	while ($row = Database::fetch_array($resultCourses)){

		$course_code = $row["code"];

		$avg_student_progress = Tracking::get_avg_student_progress(
			$userId,
			$course_code,
			[]
		);
		$avgCourseTime += $avg_student_progress;
		$ttcourse = $ttcourse + 1;
	}
	if($ttcourse>0&&$avgCourseTime>0){
		return round($avgCourseTime/$ttcourse);
	}else{
		return 0;
	}
	
}

function getTimeFull($userId,$dateStart,$dateEnd){

	$totalCourseTime = 0;

	$sql  = " SELECT DISTINCT course.id,course.code ";
	$sql .= " FROM c_lp_item_view ";
	$sql .= " INNER JOIN course ON c_lp_item_view.c_id = course.id ";
	$sql .= " WHERE lp_view_id  ";
	$sql .= " IN (SELECT id FROM `c_lp_view` WHERE user_id = $userId);";
	
	$resultCourses = Database::query($sql);

	while ($row = Database::fetch_array($resultCourses)){

		$courseId = $row["id"];
		
		$timeInSeconds = get_time_spent_on_the_course_by_date(
			$userId,
			$courseId,0,
			$dateStart,
			$dateEnd
		);
		$totalCourseTime += $timeInSeconds;

	}
	
	return $totalCourseTime;

}

function getTimeFullElearning($userId,$dateStart,$dateEnd){

	$totalCourseTime = 0;
	$dSta = new DateTime($dateStart);
	$yearS = $dSta->format("Y");
	$monthS = $dSta->format("n");

	$dEnd = new DateTime($dateEnd);
	$yearE = $dEnd->format("Y");
	$monthE = $dEnd->format("n");

	$sql  = " SELECT total_time, ";
	$sql .= " YEAR( CAST(FROM_UNIXTIME(c_lp_item_view.start_time) as date) ) as yeardate ";
	$sql .= " FROM c_lp_item_view "; 
	$sql .= " WHERE ";
	$sql .= " lp_view_id "; 
	$sql .= " IN (SELECT id FROM c_lp_view WHERE user_id = $userId); ";

	$resultByItems = Database::query($sql);

	while ($row = Database::fetch_array($resultByItems)){

		$timeInSeconds = $row["total_time"];

		$yeardate = intval($row["yeardate"]);
		if($yeardate==$yearS||$yeardate==$yearE){
			$totalCourseTime += $timeInSeconds;
		}

	}
	
	return $totalCourseTime;

}

/**
 * Calculates the time spent on the course by date
 *
 * @param int $user_id
 * @param int $courseId
 * @param int Session id (optional)
 * @param int dateStart
 * @param int dateEnd
 *
 * @return int Time in seconds
 */
function get_time_spent_on_the_course_by_date(
	$user_id,
	$courseId,
	$session_id,
	$dateStart,
	$dateEnd
){
	$courseId = (int) $courseId;

	if (empty($courseId) || empty($user_id)) {
		return 0;
	}
	
	if (Tracking::minimumTimeAvailable($session_id, $courseId)) {
		$courseTime = Tracking::getCalculateTime($user_id, $courseId, $session_id);
		$time = isset($courseTime['total_time']) ? $courseTime['total_time'] : 0;
		echo '';
		return $time;
	}

	$dSta = new DateTime($dateStart);
	$yearS = $dSta->format("Y");
	$monthS = $dSta->format("n");

	$dEnd = new DateTime($dateEnd);
	$yearE = $dEnd->format("Y");
	$monthE = $dEnd->format("n");

	$session_id = (int) $session_id;
	if (is_array($user_id)) {
		$user_id = array_map('intval', $user_id);
		$conditionUser = " AND user_id IN (".implode(',', $user_id).") ";
	} else {
		$user_id = (int) $user_id;
		$conditionUser = " AND user_id = $user_id ";
	}
	
	$table = Database::get_main_table(TABLE_STATISTIC_TRACK_E_COURSE_ACCESS);
	$sql = "SELECT 
	SUM(UNIX_TIMESTAMP(logout_course_date) - UNIX_TIMESTAMP(login_course_date)) as nb_seconds
	FROM $table WHERE 
	UNIX_TIMESTAMP(logout_course_date) > UNIX_TIMESTAMP(login_course_date) AND 
	c_id = '$courseId' ";

	$sql .= " AND (";
	$sql .= " ( YEAR(login_course_date) = $yearS OR YEAR(login_course_date) > $yearS ) ";
	$sql .= " AND (YEAR(logout_course_date) = $yearE OR YEAR(logout_course_date) < $yearE )";
	$sql .= " AND (MONTH(login_course_date) = $monthS OR  MONTH(login_course_date) > $monthS )";
	$sql .= " AND (MONTH(logout_course_date) = $monthS OR MONTH(logout_course_date) > $monthS )";
	$sql .= " AND (MONTH(login_course_date) = $monthE OR  MONTH(login_course_date) < $monthE )";
	$sql .= " AND (MONTH(logout_course_date) = $monthE OR MONTH(logout_course_date) < $monthE )";
	$sql .= " ) ";

	//$month = $date->format('m');
	//$day = $date->format('d');

	$sql .= $conditionUser;

	//echo $sql;

	$rs = Database::query($sql);
	$row = Database::fetch_array($rs);

	return $row['nb_seconds'];
}
